import 'dart:async';
import 'dart:io';
import 'package:audio_waveforms/audio_waveforms.dart';
// import 'package:audioplayers/audioplayers.dart';
import 'package:camera/camera.dart';
import 'package:collection/collection.dart';
import 'package:date_field/date_field.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:intl/intl.dart';
import 'package:observable/observable.dart';
import 'package:photo_view/photo_view.dart';
import 'package:photo_view/photo_view_gallery.dart';
import 'package:uuid/uuid.dart';
import 'package:video_player/video_player.dart';
import 'package:xcommonwidgets/xcommonwidgets.dart';
import 'package:xfxbase/XFDataItem.dart';
import 'package:xfxbase/_XFX/XF_Col.dart';
import 'package:xfxbase/_XFX/XF_View.dart';
import 'package:xfxwidgets/XF_MAIN/XApp.dart';
import 'package:xfxwidgets/xMediaItem.dart';
import 'package:xtoolspackage/XLibStorage.dart';
import 'package:xtoolspackage/xtoolspackage.dart';
import 'package:video_thumbnail/video_thumbnail.dart' as thumb;
import 'package:image_painter/image_painter.dart';
import 'package:image/image.dart' as img;

import '../XF_SCHEDA/Xfx_Scheda.dart';
import '../XMediaPlayer.dart';
import '../XfxDropDown.dart';
import '../xfxwidgets.dart';

// extension WhereMethod<K> on Iterable<K>? {
//   Iterable<K> whereMethod({bool Function(K)? fun}) {
//     if (this != null && fun != null) {
//       return this!.where(fun);
//     } else if (this == null) {
//       return [];
//     } else {
//       return this!.toList();
//     }
//   }
// }

class XElenco<T, K extends XFDataItem> extends StatefulWidget {
  XElenco(
    this.title_Text,
    this.view, {
    Key? key,
    this.xApp,
    this.viewDetts,
    this.title_OnTop_Visible = false,
    this.headers_Visible,
    this.filters_Visible = false,
    this.heightForHeader,
    this.headers,
    this.filters,
    this.numberOfHeader,
    this.flexForList,
    this.colorBackgroundContainerElTitle,
    this.heightContainerElTitle,
    this.title_Style,
    this.BTNtitle_Label,
    this.BTNtitle_Color,
    this.BTNtitle_OnPressed,
    this.BTNtitle_Height,
    this.BTNtitle_Width,
    this.BTNtitle_Visible = false,
    this.BTNtitle_Margin,
    this.margin_Horizontal,
    this.onRefresh_ScrollDownList,
    this.item_Widget,
    this.floatingActionButton,
    this.searchBar_Active = true,
    this.allowAdd = false,
    this.cmd_Add,
    this.onDoubleTapItem,
    this.pageMode_Active = true,
    this.onTapItem,
    this.schNameToOpen,
    this.formatDate,
    this.liDetts,
    this.xDrawerMenu,
    this.appBar_Color,
    this.searchBar_Color,
    this.searchBar_ColorBorder,
    this.searchBar_ColorHint,
    this.searchBar_ColorIconClear,
    this.searchBar_ColorIconSearch,
    this.searchBar_ColorText,
    this.searchBar_hintText,
    this.searchBar_whereMethod,
    this.onPressed_MENU,
    this.liPopUpMenu_Items,
    this.itemSelected_BackGroundColor,
    this.elDettsMode_SchItem,
    this.liDettsSubArea_Widgets,
    this.edited,
    this.xOnReturnBack,
    this.noTextWhenCellValueIsNull = false,
    this.title_Color,
    this.onEditBoolValueOnItem,
    this.liWidgets_LeftArea_Item,
    this.schedaMode = false,
    this.functInItem,
    this.onLongTapItem,
    // this.whereMethod,
    this.BTNEmptyList_BL,
    this.showHead_DettsRowInItem = true,
    this.xDett_xColname,
    this.appBar_Height,
    this.xDettItem_BackGroundColor,
    this.widgetBuild_Override,
    this.appBar_Visible = true,
    this.liWidgets_RightArea_Item,
    this.showHead = true,
    this.xDett_minHeight_showHead = true,
    this.xDett_AddBTN_Active = true,
  }) : super(key: key);
  XView? view;
  XView? viewDetts;
  XApp? xApp;
  double? margin_Horizontal;
  Future<void> Function(BuildContext)? onRefresh_ScrollDownList;
  Function(K)? functInItem;
  Function()? BTNEmptyList_BL;
  bool title_OnTop_Visible;
  bool? headers_Visible;
  bool? filters_Visible;
  bool showHead_DettsRowInItem;
  String? xDett_xColname;
  double? heightForHeader;
  String? formatDate;
  List<Widget>? headers = List<Widget>.empty(growable: true);
  List<Widget>? filters = List<Widget>.empty(growable: true);
  int? numberOfHeader;
  int? flexForList;
  Color? colorBackgroundContainerElTitle;
  double? heightContainerElTitle;
  String title_Text;
  TextStyle? title_Style;
  Color? title_Color;
  String? BTNtitle_Label;
  Color? BTNtitle_Color;
  Function()? BTNtitle_OnPressed;
  double? BTNtitle_Height;
  double? BTNtitle_Width;
  bool? BTNtitle_Visible;
  EdgeInsets? BTNtitle_Margin;
  Widget? Function(K)? item_Widget;
  Color? appBar_Color;
  Widget? floatingActionButton;
  Widget? xDrawerMenu;
  Widget? Function(dynamic)? liDettsSubArea_Widgets;
  Function(void Function(void Function()))? xOnReturnBack;
  bool searchBar_Active;
  Color? searchBar_ColorHint;
  Color? searchBar_ColorText;
  Color? searchBar_ColorIconClear;
  Color? searchBar_ColorIconSearch;
  Color? searchBar_Color;
  Color? searchBar_ColorBorder;
  String? searchBar_hintText;
  List<Widget>? Function(K)? liWidgets_LeftArea_Item;
  List<Widget>? Function(K)? liWidgets_RightArea_Item;
  bool Function(K, String)? searchBar_whereMethod;
  ValueNotifier<bool>? edited;
  bool allowAdd;
  bool? schedaMode;
  double? appBar_Height;
  Function(void Function(void Function()))? cmd_Add;
  Function()? onDoubleTapItem;
  Function(K)? onTapItem;
  Function(dynamic)? onLongTapItem;

  Function()? onPressed_MENU;
  String? schNameToOpen;
  Function(XCol, bool)? onEditBoolValueOnItem;
  Color? itemSelected_BackGroundColor;
  Color? xDettItem_BackGroundColor;

  bool noTextWhenCellValueIsNull;
  bool pageMode_Active;
  bool? elDettsMode_SchItem;
  bool appBar_Visible;
  Widget? widgetBuild_Override;

  bool? borderAree_Header;
  bool showHead;
  bool xDett_minHeight_showHead;
  bool xDett_AddBTN_Active;

  List<XPopUpMenuItem>? liPopUpMenu_Items = List<XPopUpMenuItem>.empty(growable: true);
  List<dynamic>? liDetts;
  //bool Function(K, String?)? whereMethod;
  @override
  XElencoState<T, K> createState() => XElencoState<T, K>();
}

class XElencoState<T, K extends XFDataItem> extends State<XElenco<T, K>> with SingleTickerProviderStateMixin {
  ScrollController? scroll_controller = ScrollController();
  TextEditingController searchController = TextEditingController();

  Future<List<K>> Function()? xLoadData_apiCall = null;
  List<K> Function()? xLoadData_get = null;
  List<K> list = List<K>.empty(growable: true);
  ObservableList<K>? xListSourceObservable;

  List<XMediaItem> liMediaRAW = List<XMediaItem>.empty(growable: true);

  bool isBusy = true;
  Color? cell_borderColor;
  Color? cell_borderColor_Disabled;
  Color? cell_labelColor_Disabled;
  static String filterAll = "TUTTI";
  String filterCurrent = "";
  String? filterValue;
  Timer? timerSearch;

  String xFormat_Date = "dd/MM";

  AnimationController? _swipingAnimationController;
  static bool media_isActive = false;

  String waiterMessage = "";
  //Per gestire EditDialog
  List<XProp> xEditDialog_liProps = List<XProp>.empty(growable: true);
  String xEditDialog_EditCell = "";
  bool borderColor_Active = false;

  List<XProp> xFilter_SearchBarXCols = List<XProp>.empty(growable: true);
  List<XFilterEl<dynamic>> xFilter_XFilters = List<XFilterEl<dynamic>>.empty(growable: true);

  //Per Audio
  // List<AudioPlayer>? audioPlayers;
  int selectedPlayerIdx = 0;
  // FlutterSoundRecorder? _audioRecorder = FlutterSoundRecorder();
  // AudioPlayer get selectedAudioPlayer => audioPlayers![selectedPlayerIdx];
  final _imageKey = GlobalKey<ImagePainterState>();

  bool? createAudio = false;
  File? xFileUI;
  File? file;

  late PlayerController controller;
  late StreamSubscription<PlayerState> playerStateSubscription;

  final playerWaveStyle = const PlayerWaveStyle(
    fixedWaveColor: Colors.white54,
    liveWaveColor: Colors.white,
    spacing: 6,
  );

  @override
  void initState() async {
    if (widget.edited == null) {
      widget.edited = ValueNotifier(false);
    }
    xLoadDataOnly();
    initXFilters();
    // audioPlayers = [AudioPlayer(playerId: "1")];
    _swipingAnimationController = AnimationController(duration: const Duration(milliseconds: 200), vsync: this);
    searchController.addListener(
      () {
        setState(() {
          filterValue = searchController.text;
          if (timerSearch != null) timerSearch!.cancel();
          timerSearch = Timer(Duration(milliseconds: 300), timerSearchHandlerList);
        });
      },
    );
    if (xListSourceObservable != null) {
      xListSourceObservable!.changes.listen((event) {
        // if (this.context.mounted)
        neededRealoadData = true;
        //   xLoadDataOnly();
        // else
        // neededRealoadData = true;
      });
    }
    super.initState();
    controller = PlayerController();
    playerStateSubscription = controller.onPlayerStateChanged.listen((_) {
      setState(() {});
    });
  }

  void _preparePlayer(XMediaItem item) async {
    // Opening file from assets folder
    var rawFile = Directory("${XLibStorage.filePath}/AUDIO/").listSync().firstWhereOrNull((e) => e.path.contains(item.id));
    file = File(rawFile!.path);
    await file?.writeAsBytes((await rootBundle.load('assets/audios/audio${item.id}.aac')).buffer.asUint8List());
    // Prepare player with extracting waveform if index is even.
    controller.preparePlayer(
      path: file!.path,
      shouldExtractWaveform: true,
    );
    // Extracting waveform separately if index is odd.
    controller
        .extractWaveformData(
          path: file!.path,
          noOfSamples: playerWaveStyle.getSamplesForWidth(200),
        )
        .then((waveformData) => debugPrint(waveformData.toString()));
  }

  bool neededRealoadData = false;

  ///Mettere quì il codice di inite degli XFilters
  void initXFilters() {}
  @override
  void dispose() {
    searchController.dispose();
    if (_swipingAnimationController != null) {
      _swipingAnimationController!.dispose();
      _swipingAnimationController = null;
    }
    super.dispose();
  }

  _xFilter_build() {
    if (xFilter_XFilters.isEmpty) return Container();
    return Row(
      children: [
        /// LABELS    /// LABELS /// LABELS    /// LABELS /// LABELS    /// LABELS
        xFilter_XFilters.length == 1
            // SINGOLO
            ? Container()
            // MULTI XFILTER
            : Container(
                width: 170,
                child: Column(children: [
                  Wrap(
                    children: xFilter_XFilters
                        .map((e) => Container(
                              width: 170,
                              child: Row(
                                children: [
                                  Text(
                                    e.xPropOfItemToFilter.col_Label,
                                    style: XStyles.xStyTextForSubDescr(e.xPropOfItemToFilter.col_Color == Colors.black ? XColors.foregroundLight : e.xPropOfItemToFilter.col_Color),
                                  ),
                                  SizedBox(width: 10),
                                  Expanded(
                                      child: Container(
                                          padding: EdgeInsets.symmetric(horizontal: 4),
                                          color: (e.Value is XEnumDef ? (e.Value as XEnumDef).backColor : null),
                                          child: Text(
                                            XfxUtils.xddValueToString(e.Value, e.ColsOfXFdataItemToShow),
                                            style: XStyles.xStyTextForSubDescr((e.Value is XEnumDef ? (e.Value as XEnumDef).textColor : XColors.foregroundLight)),
                                          ))),
                                ],
                              ),
                            ))
                        .toList(),
                  )
                ]),
              ),
        // UI XFILTER con VALUE
        // UI XFILTER con VALUE
        // UI XFILTER con VALUE
        // UI XFILTER con VALUE
        // UI XFILTER con VALUE
        xFilter_XFilters.length == 1
            // SINGOLO XFILTER
            ? Container(
                width: 170,
                child: XfxDropDown<dynamic>(xFilter_XFilters.first.ColsOfXFdataItemToShow,
                    label: "",
                    liItems: xFilter_XFilters.first.Items,
                    itemSelected: xFilter_XFilters.first.Value,
                    background_Color: (value) => xFilter_XFilters.first.xPropOfItemToFilter.col_Color,
                    label_Behavior: FloatingLabelBehavior.auto,
                    clearBTN_Active: xFilter_XFilters.first.All != null && xFilter_XFilters.first.Value != xFilter_XFilters.first.All,
                    onChanged_ItemOfDD: (value) {
                      setState(() {
                        xFilter_XFilters.first.Value = value == null ? xFilter_XFilters.first.All : value;
                        print(xFilter_XFilters.first.Value);
                      });
                    }))
            //MULTI XFILTER
            : Container(
                width: 40,
                child: PopupMenuButton(
                  icon: Icon(Icons.filter_alt_outlined),
                  itemBuilder: (context) {
                    return xFilter_XFilters.map((e) => xFilter_Builder_XFilterEl(e)).toList();
                  },
                ))
      ],
    );
  }

  PopupMenuItem xFilter_Builder_XFilterEl(XFilterEl<dynamic> xf) {
    return PopupMenuItem(
        child: Row(children: [
      Container(
          width: 240,
          child: XfxDropDown<dynamic>(xf.ColsOfXFdataItemToShow,
              label: "",
              liItems: xf.Items,
              itemSelected: xf.Value,
              background_Color: (value) => xf.xPropOfItemToFilter.col_Color,
              label_Behavior: FloatingLabelBehavior.auto,
              clearBTN_Active: xf.All != null,
              clearBTN_getValueForCLEAR: () => xf.All,
              onChanged_ItemOfDD: (value) {
                setState(() {
                  xf.Value = value == null ? xf.All : value;
                  print(xf.Value);
                });
              }))
    ]));
  }

  bool _xFilter_FilterItem(K item) {
    // widget.whereMethod!(element, filterCurrent)
    var rval = true;
    // se ci sono appli XFilterEl
    if (xFilter_XFilters.isNotEmpty) {
      for (var xf in xFilter_XFilters) {
        var propNameReal = xf.xPropOfItemToFilter.col_Name;
        if (propNameReal.endsWith("ID")) propNameReal += "_resolved";

        if (xf.Value == xf.All)
          rval = true;
        else if (xf.Value is XFDataItem) {
          if (xf.xPropOfItemToFilter.col_Name.endsWith("ID"))
            rval = item[xf.xPropOfItemToFilter.col_Name]! == (xf.Value as XFDataItem).id;
          else
            rval = item[xf.xPropOfItemToFilter.col_Name]! == (xf.Value as XFDataItem)[xf.ColsOfXFdataItemToShow.first.col_Name];
        } else if (xf.Value is XEnumDef) {
          rval = item[xf.xPropOfItemToFilter.col_Name]! == (xf.Value as XEnumDef).value;
        } else {
          rval = item[propNameReal]! == xf.Value!;
        }
        if (!rval) return false;
      }
    }
    if (filterCurrent.isNotEmpty && xFilter_SearchBarXCols.isNotEmpty) {
      var searchBarResult = false;
      for (XProp pippo in xFilter_SearchBarXCols) {
        var propNameReal = pippo.col_Name;
        if (propNameReal.endsWith("ID")) propNameReal += "_resolved";

        searchBarResult = item[propNameReal]!.toLowerCase().contains(filterCurrent.toLowerCase());
        if (searchBarResult) {
          break;
        }
      }
      if (searchBarResult) return searchBarResult;

      if (widget.searchBar_whereMethod != null) return widget.searchBar_whereMethod!(item, filterCurrent);
      return searchBarResult;
    }
    return true;
  }

  void rebuildAllChildren(BuildContext context) {
    void rebuild(Element el) {
      el.markNeedsBuild();
      el.visitChildren(rebuild);
    }

    (context as Element).visitChildren(rebuild);
  }

  timerSearchHandlerList() {
    setState(() {
      if (timerSearch != null) timerSearch!.cancel();
      if (filterValue != "") {
        filterCurrent = filterValue.toString();
      } else if (filterValue == "") {
        filterCurrent = "";
      }
    });
  }

  xLoadDataOnly() {
    setState(() {
      isBusy = true;
    });
    if (xLoadData_get != null) {
      list.clear();
      list.addAll(xLoadData_get!());
      setState(() {
        isBusy = false;
        xAfter_LoadData_Done();
      });
    }
    if (xLoadData_apiCall != null) {
      xLoadData_apiCall!().then((value) {
        list.clear();
        list.addAll(value);
      }).whenComplete(() {
        setState(() {
          isBusy = false;
          xAfter_LoadData_Done();
        });
      });
    }
    neededRealoadData = false;
  }

  xAfter_LoadData_Done() {}

  List<Widget> xLayout_WidgetsLeftArea_Item(K item, void Function(void Function()) parentSetState) {
    return widget.liWidgets_LeftArea_Item != null ? widget.liWidgets_LeftArea_Item!(item)! : [];
  }

  List<Widget> xLayout_WidgetsRightArea_Item(K item, void Function(void Function()) parentSetState) {
    return widget.liWidgets_LeftArea_Item != null ? widget.liWidgets_LeftArea_Item!(item)! : [];
  }

  xOnTapItem(K item) async {
    return null;
  }

  Widget? xLayout_DettItemWidget(dynamic item) {
    if (widget.liDettsSubArea_Widgets != null) {
      return widget.liDettsSubArea_Widgets!(item);
    } else {
      return null;
    }
  }

  Widget xLayout_CheckBox_Widget(bool value, XCol xCol) {
    return Checkbox(
        value: value,
        onChanged: (value) {
          setState(() {
            value = value;
            widget.edited!.value = true;
            widget.onEditBoolValueOnItem!(xCol, value ?? false);
          });
        });
  }

  Future xOnLongTapItem(dynamic item) async {
    return (widget.onLongTapItem != null) ? (widget.onLongTapItem!(item)) : null;
  }

  Future<bool> xCMD_DeleteFromList(XFDataItem itemToRemove, String title, {required Function(String) cmd_Delete}) async {
    bool x = await showDialog(
        barrierDismissible: false,
        context: context,
        builder: (builder) {
          return XAlertDialog(
            btnNO_label: "NO",
            btnYES_label: "SI",
            btnYES_OnPressed: () => Navigator.pop(context, true),
            btnNO_OnPressed: () => Navigator.pop(context, false),
            title_Text: title,
            title_Style: XStyles.xStyTextForSubLabel(Colors.yellow),
          );
        });

    if (x) {
      var res;
      if (list.isEmpty || (widget.liDetts != null && widget.liDetts!.isEmpty)) {
        if (widget.liDetts != null) {
          res = widget.liDetts!.firstWhereOrNull((element) => element.id == itemToRemove.id);
        } else {
          res = list.firstWhereOrNull((element) => element.id == itemToRemove.id);
        }
      }
      widget.edited!.value = true;
      if (res != null) {
        if (itemToRemove.id == "") {
          return false;
        } else {
          if (widget.liDetts != null) {
            widget.liDetts!.remove(itemToRemove);
          } else {
            list.remove(itemToRemove);
          }
          setState(() {});
          await cmd_Delete(itemToRemove.id);

          return true;
        }
      } else {
        return false;
      }
    } else {
      setState(() {});
      return false;
    }
  }

//TextFormField Editor Generico da Usare
  Widget xSch_TextFormField_Builder<T>({
    required BuildContext context,
    required XCol xCol,
    Function(String)? onChanged,
    Function(String)? onSubmitted,
    String? hintText,
    List<TextInputFormatter>? inputFormatters,
    TextInputType? keyboardType,
    bool editable = true,
    bool label_Visible = true,
    bool autoFocus = false,
    String? value,
    bool? selectText,
    bool? multiLines,
    double? height,
    int? maxLines,
    Color? borderColor,
    Color? borderColor_Disabled,
    Color? labelColor_Disabled,
    Color? backgorundColor,
    Color? backgorundColor_Disabled,
    TextEditingController? controller,
    Function()? onBefore_Edit,
  }) {
    OutlineInputBorder o = OutlineInputBorder(borderSide: BorderSide(color: editable.not() ? (borderColor_Active ? (xCol.xmodelXprop.col_Color == Colors.black ? (borderColor ?? Colors.grey[400]!) : xCol.xmodelXprop.col_Color) : borderColor ?? Colors.grey[400]!) : (borderColor_Disabled ?? Colors.grey[400]!), width: 1));
    return XTextFormField(
      controller: value != null ? null : controller,
      border: o,
      disabledBorder: o,
      enabledBorder: o,
      // byRick: label: label_Visible ? (xCol.colCaption + (xCol.format == "C" ? " €" : "")) : "",
      label: label_Visible ? xCol.colCaption + (editable ? "🔒" : "") : "",
      onChanged: onChanged,
      onFieldSubmitted: (value) {
        onSubmitted == null ? null : onSubmitted(value!);
      },
      autoFocus: autoFocus,
      onTap: () {
        if (controller != null) {
          if (xCol.dataType == String) {
          } else {
            controller.selection = TextSelection(baseOffset: 0, extentOffset: controller.text.length);
          }
        }
        onBefore_Edit!();
      },
      initialValue: controller != null ? null : value,
      // borderVisible: editable.not(),
      maxLines: maxLines,
      isCollapsed: false,
      enabled: editable.not(),
      height: null,
      fillColor: editable ? Colors.transparent : XSchedaState.color_CellBackGorundDisabled,
      filled: XSchedaState.color_CellBackGorundDisabled != null ? true : false,
      multiLines: (xCol.colCaption.toLowerCase().contains("email") || (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto")) || xCol.colCaption.toLowerCase().contains("inidrizzo") || xCol.colCaption.toLowerCase().contains("ind"))
          ? false
          : ((xCol.colCaption.toLowerCase().contains("cell")) || (xCol.colCaption.toLowerCase().contains("tel")))
              ? false
              : multiLines ?? false,
      contentPadding: EdgeInsets.only(top: 7, left: 5, bottom: 7),
      textStyle: XStyles.xStyleText(colorText: XSchedaState.color_Text),
      textAlign: xCol.dataType is int || xCol.dataType is double ? TextAlign.end : TextAlign.start,
      labelStyle: XStyles.xStyTextForLabel(xCol.xmodelXprop.col_Color == Colors.black ? XColors.foregroundLight : xCol.xmodelXprop.col_Color), //XSchedaState.colorOfHintText
      keyboardType: keyboardType ??
          ((xCol.colCaption.toLowerCase().contains("email"))
              ? TextInputType.emailAddress
              : ((xCol.colCaption.toLowerCase().contains("cell")) || (xCol.colCaption.toLowerCase().contains("tel")))
                  ? TextInputType.phone
                  : (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto"))
                      ? TextInputType.number
                      : TextInputType.text),
      textCapitalization: (xCol.dataType == String && xCol.colKey.startsWith("li").not())
          ? TextCapitalization.sentences //
          : TextCapitalization.none,
      hintText: editable ? "..." : (hintText ?? "..."),
      hintStyle: XStyles.xStyTextForSubDescr(XSchedaState.color_HintText),
      inputFormatters: inputFormatters ?? [],
    );
  }

//Text Generico da Usare
  Widget xSch_Text_Builder<T>({required BuildContext context, required XCol xCol, required String value, List<TextInputFormatter>? inputFormatters, double? height}) {
    return XTextWithLabel(
      label: xCol.colCaption,
      text: xCol.format == "C" ? XUtils.xFormatToCurrency(context, double.parse(value)) : value,
      text_Style: XStyles.xStyTextForDescr(Colors.white),
      label_Style: XStyles.xStyTextForLabel(XSchedaState.color_HintText),
    );
  }

  //quando salvo ciclo per tutte le prop dell'attore e salvo le informazioni
  ///chiamato quando il valore cambia all'interno dell EDITOR della CELLA
  xOnXCell_Edit_OnChanged(XFDataItem itemInEdit, XCol xCol, dynamic newValue) async {}

  ///called in a setState
  xOnXCell_Edit_AfterSubmit(XFDataItem itemInEdit, XCol xCol, dynamic newValue, bool valueIsChanged, {dynamic valueForResolved = null, dynamic valueForRealCol = null}) {}
  xOnXCell_Edit_BeforeSubmit(XFDataItem itemInEdit, XCol xCol, dynamic newValue, bool valueIsChanged, {dynamic valueForResolved = null, dynamic valueForRealCol = null}) async {}

  //Da chiamare per Confermare l'edit di un dato
  /// valueForRealCol = value da mettere nella col reale: es artID noi abbiamo sempre colKey = artiID_resolved, la RealCol
  xOnXCell_Edit_SubmitValue_INTERNAL(XFDataItem itemInEdit, XCol xCol, dynamic newValue, {dynamic valueForResolved = null, dynamic valueForRealCol = null}) {
    var valueIsChanged;
    if (newValue != null && newValue is XEnumDef)
      valueIsChanged = itemInEdit[xCol.colKey] != (valueForRealCol ?? newValue.value!);
    else
      valueIsChanged = itemInEdit[xCol.colKey] != (valueForRealCol ?? newValue);

    xOnXCell_Edit_BeforeSubmit(itemInEdit, xCol, newValue, valueIsChanged, valueForResolved: valueForResolved, valueForRealCol: valueForRealCol);
    xOnXCell_Edit_SubmitValue_ToItem(itemInEdit, xCol, newValue, valueIsChanged, valueForResolved: valueForResolved, valueForRealCol: valueForRealCol);
    xOnXCell_Edit_AfterSubmit(itemInEdit, xCol, newValue, valueIsChanged, valueForResolved: valueForResolved, valueForRealCol: valueForRealCol);
  }

  xOnXCell_Before_Edit(XCol xCol, dynamic value, {dynamic itemToSet}) async {
    if (xEditDialog_liProps.isEmpty) {
      xEditDialog_EditCell = xCol.colCaption;
    } else {
      for (var i in xEditDialog_liProps) {
        xEditDialog_EditCell = " " + i.col_Label;
      }
    }

    setState(() {});
    return () {};
  }

  /// only itemInEdit[xCol.colKey] = value!;
  xOnXCell_Edit_SubmitValue_ToItem(XFDataItem itemInEdit, XCol xCol, dynamic newValue, bool valueIsChanged, {dynamic valueForResolved = null, dynamic valueForRealCol = null}) {
    if (newValue is XEnumDef) {
      itemInEdit[xCol.colKey] = newValue.value;
    } else {
      // ID & _resolved
      if (xCol.colKey.endsWith("_resolved")) {
        if (valueForResolved != null) {
          itemInEdit[xCol.colKey] = valueForResolved!;
        }
        if (valueForRealCol != null) // parte del campo vero, senza _resolved
        {
          itemInEdit[xCol.colKey.replaceAll("_resolved", "")] = valueForRealCol!;
        } else {
          itemInEdit[xCol.colKey] = newValue;
        }
      } else {
        itemInEdit[xCol.colKey] = valueForRealCol ?? newValue;
      }
    }
  }

//DateTime Editor Generico da Usare
  Widget xSch_DateFormField_Builder({
    required XCol xCol,
    required Function(DateTime)? onDateSelected,
    bool editable = true,
    DateTime? value,
    Color? borderColor,
    Color? borderColor_Disabled,
    Color? labelColor_Disabled,
    Function()? onBefore_Edit,
    TextEditingController? controller,
    String? format,
  }) {
    OutlineInputBorder o = OutlineInputBorder(borderSide: BorderSide(color: xCol.readOnly.not() ? (borderColor_Active ? xCol.xmodelXprop.col_Color : borderColor ?? Colors.grey[400]!) : (borderColor_Disabled ?? Colors.grey[800]!), width: 1));
    return GestureDetector(
        child: DateTimeFormField(
            decoration: InputDecoration(
              contentPadding: EdgeInsets.only(right: 2, top: 2, bottom: 2, left: 4),
              hintStyle: XStyles.xStyleText(fontSize: 15, colorText: XSchedaState.color_HintText),
              errorStyle: TextStyle(color: Colors.redAccent),
              border: o,
              disabledBorder: o,
              enabledBorder: o,
              labelText: xCol.colCaption,
              constraints: BoxConstraints(maxHeight: 40),
              labelStyle: value != null
                  ? XStyles.xStyTextForLabel(xCol.readOnly ? (labelColor_Disabled ?? borderColor_Disabled ?? Colors.grey[900]!) : (labelColor_Disabled ?? borderColor ?? Colors.grey[600]!)) //
                  : XStyles.xStyTextForDescr(editable.not() ? (labelColor_Disabled ?? borderColor_Disabled ?? Colors.grey[700]!) : (xCol.xmodelXprop.col_Color != Colors.black ? xCol.xmodelXprop.col_Color : XColors.foregroundLight)),
            ),
            enabled: xCol.readOnly.not(),
            initialValue: value,
            dateFormat: DateFormat(format ?? "dd/MM/yy"),
            dateTextStyle: XStyles.xStyleText(fontSize: 15, colorText: Colors.white),
            initialEntryMode: DatePickerEntryMode.calendar,
            initialDatePickerMode: DatePickerMode.day,
            mode: DateTimeFieldPickerMode.date,
            autovalidateMode: AutovalidateMode.onUserInteraction,
            validator: (e) => (e?.day ?? 0) == 1 ? 'Perfavore sistema la data' : null,
            onDateSelected: (value) => onDateSelected!(value)));
  }

//Preview dell'aggiunta di un nuovo Item
  Future<XFDataItem?> xPreview_Dialog(XView xView, dynamic value) async {
    dynamic valueUI = value.getCloneFull();
    return await showDialog<XFDataItem>(
        context: context,
        builder: (context) {
          return StatefulBuilder(builder: (context, setState) {
            return Container(
                width: MediaQuery.of(context).size.width - 20,
                alignment: Alignment.center,
                child: SingleChildScrollView(
                    child: XAlertDialog(
                  colorBackGround: XSchedaState.color_BackGround_EditDialog,
                  title_Text: "Anteprima Aggiunta",
                  btnNO_label: "Annulla",
                  btnYES_label: "Salva",
                  btnYES_OnPressed: () {
                    xView.cols.forEach((e) {
                      // TextEditingController controller = TextEditingController(text: value[e.colKey].toString());
                      if (e.colKey.startsWith("li").not() && e.dataType != bool && e.readOnly == false) {
                        value[e.colKey] = valueUI[e.colKey];
                      }
                    });
                    return Navigator.pop(context, value);
                  },
                  btnNO_OnPressed: () {
                    return Navigator.pop(context, null);
                  },
                  child: Column(
                    mainAxisSize: MainAxisSize.min,
                    children: xView.cols.map((e) {
                      // TextEditingController controller = TextEditingController(text: value[e.colKey].toString());
                      if (e.colKey.startsWith("li").not() && e.dataType != bool && e.readOnly == false) {
                        return Container(margin: EdgeInsets.symmetric(vertical: 5), child: xLayout_CellWidget_Editable(e, valueUI, context, valueUI) //

                            );
                      } else {
                        return Container();
                      }
                    }).toList(),
                  ),
                )));
          });
        });
  }

  ///BUILDER DEI WIDGET EDITABILI///
  Container xLayout_CellWidget_Editable(XCol xCol, dynamic item, BuildContext context, dynamic itemToSet, {bool onBeforeCMD_Active = true, TextEditingController? controller}) {
    late Widget _widgetForCell;
    //WIDGET NEL CASO FOSSE UNA STRING
    if (xCol.dataType == String && xCol.colKey.startsWith("li").not() && xCol.dataType != bool) {
      _widgetForCell = xSch_TextFormField_Builder(
        height: null,
        context: context,
        controller: controller,
        xCol: xCol,
        multiLines: xCol.width >= 200 ? true : false,
        editable: xCol.readOnly,
        borderColor: cell_borderColor,
        borderColor_Disabled: cell_borderColor_Disabled,
        labelColor_Disabled: cell_labelColor_Disabled,
        onSubmitted: (value) {
          xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
        },
        onBefore_Edit: () {
          if (onBeforeCMD_Active) {
            xOnXCell_Before_Edit(xCol, item[xCol.colKey], itemToSet: itemToSet);
          }
        },
        value: item[xCol.colKey] ?? "",
        onChanged: (value) {
          xOnXCell_Edit_OnChanged(item, xCol, value);
        },
      );
    }
    //WIDGET NEL CASO FOSSE UN DATETIME
    else if (xCol.dataType == DateTime) {
      _widgetForCell = xSch_DateFormField_Builder(
          xCol: xCol,
          borderColor: cell_borderColor,
          borderColor_Disabled: cell_borderColor_Disabled,
          labelColor_Disabled: cell_labelColor_Disabled,
          format: xFormat_Date,
          onBefore_Edit: () => xOnXCell_Before_Edit(xCol, item),
          value: item[xCol.colKey] == DateTime(1900, 01, 01) ? null : item[xCol.colKey],
          onDateSelected: (value) {
            xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
          });
    }
    //WIDGET NEL CASO FOSSE UN DOUBLE
    else if (xCol.dataType == double) {
      _widgetForCell = xSch_TextFormField_Builder(
          context: context,
          selectText: true,
          editable: xCol.readOnly,
          xCol: xCol,
          controller: controller,
          maxLines: 1,
          borderColor: cell_borderColor,
          borderColor_Disabled: cell_borderColor_Disabled,
          labelColor_Disabled: cell_labelColor_Disabled,
          onBefore_Edit: () {
            if (onBeforeCMD_Active) {
              xOnXCell_Before_Edit(xCol, item, itemToSet: itemToSet);
            }
          },
          keyboardType: TextInputType.number,
          value: (item[xCol.colKey] == null || item[xCol.colKey].toString() == "0.0") ? "" : XUtils.xFormatDouble(context, item[xCol.colKey]),
          inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
          onSubmitted: (value) {
            xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, double.parse(value));
          },
          onChanged: (value) {
            if (value != "") {
              xOnXCell_Edit_OnChanged(item, xCol, double.parse(value));
            } else {
              xOnXCell_Edit_OnChanged(item, xCol, 0.0);
            }
          });
    }
    //WIDGET NEL CASO FOSSE UN INTERO
    else if (xCol.dataType == int) {
      _widgetForCell = xSch_TextFormField_Builder(
        context: context,
        editable: xCol.readOnly,
        selectText: true,
        maxLines: 1,
        controller: controller,
        xCol: xCol,
        borderColor: cell_borderColor,
        borderColor_Disabled: cell_borderColor_Disabled,
        labelColor_Disabled: cell_labelColor_Disabled,
        keyboardType: TextInputType.number,
        onBefore_Edit: () {
          if (onBeforeCMD_Active) {
            xOnXCell_Before_Edit(xCol, item, itemToSet: itemToSet);
          }
        },
        onSubmitted: (value) {
          xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
        },
        value: item[xCol.colKey].toString() == "0.0" ? "" : XUtils.xFormatInt(context, item[xCol.colKey]),
        inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
        onChanged: (value) {
          if (value != "") {
            xOnXCell_Edit_OnChanged(item, xCol, int.parse(value));
          } else {
            xOnXCell_Edit_OnChanged(item, xCol, 0);
          }
        },
      );
    } else if (xCol.dataType == bool) {
      _widgetForCell = Container(
        child: XCheckBoxWidget(
            verticalCheckBoxWidget: true,
            label: xCol.colCaption,
            label_Color: xCol.xmodelXprop.col_Color != Colors.black ? xCol.xmodelXprop.col_Color : XColors.foregroundLight,
            activeColor: xCol.xmodelXprop.col_Color != Colors.black ? xCol.xmodelXprop.col_Color : XColors.foregroundLight,
            checkColor: XColors.foregroundDark,
            value: (item[xCol.colKey] ?? false),
            onChanged: (value) async {
              setState(() {
                xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
                // editedPage.value = true;
                item[xCol.colKey] = value;
              });
            }),
      );
    } else {
      //DEVE essere W e H = 0 se no il Wrap fa casino nel gestirlo e va a "un po' a capo" dopo l'ultimo Widget
      return Container(width: 0, height: 0);
    }
    return Container(
      width: xCol.width,
      padding: xCol.dataType == DateTime ? EdgeInsets.only(top: 1 * (XUtils.kforScale)) : null,
      child: _widgetForCell,
    );
    //}
  }

  Widget? xLayout_ItemWidget(K item) {
    late List<XFDataItem> liDettsUI;
    if (widget.xDett_xColname != null) {
      liDettsUI = item[widget.xDett_xColname!];
    }
    return widget.schedaMode == true
        ? XElencoItem(item, widget.view!,
            funct: widget.functInItem != null ? () => widget.functInItem!(item) : null,
            showingDetails: item.isShowDetails,
            margin: EdgeInsets.symmetric(vertical: 2),
            backGroundColor_ChildMain: (item.isShowDetails && widget.elDettsMode_SchItem == true ? Colors.grey[900] : widget.itemSelected_BackGroundColor ?? (widget.appBar_Color == null ? widget.itemSelected_BackGroundColor ?? Colors.grey[900] : widget.appBar_Color!.withAlpha(30))),
            backGroundColor_ChildDetails: (item.isShowDetails ? Colors.grey[900] : widget.itemSelected_BackGroundColor ?? (widget.appBar_Color == null ? widget.itemSelected_BackGroundColor ?? Colors.grey[900] : widget.appBar_Color!.withAlpha(30))),
            onDoubleTapItem: widget.onDoubleTapItem,
            showTrailingArrow: false,
            widgets_RightArea: xLayout_WidgetsRightArea_Item(item, setState),
            widgets_LeftArea: xLayout_WidgetsLeftArea_Item(item, setState),
            onTapItem: () async {
              var x = await xOnTapItem(item);
              if (x == null) {}

              widget.onTapItem != null ? () => widget.onTapItem!(item) : null;
            },
            onLongTapItem: () => xOnLongTapItem(item),
            xLayout_Item_RowWidgets: (xCol, item) => xLayout_Item_RowWidgets(xCol, item),
            edited: widget.edited!,
            //Widget che raffigura i dettagli che sono dentro la riga espansa
            childDetails: Column(mainAxisSize: MainAxisSize.min, children: [(widget.liDettsSubArea_Widgets != null ? widget.liDettsSubArea_Widgets!(item) ?? Container() : Container())]))
        : (widget.elDettsMode_SchItem != null && widget.elDettsMode_SchItem!)
            ? xLayout_DettItemWidget(item) ??
                XElencoItem(item, widget.view!,
                    funct: widget.functInItem != null ? () => widget.functInItem!(item) : null,
                    showingDetails: item.isShowDetails,
                    margin: EdgeInsets.symmetric(vertical: 2),
                    backGroundColor_ChildMain: widget.itemSelected_BackGroundColor ?? (widget.appBar_Color == null ? widget.itemSelected_BackGroundColor ?? Colors.grey[900] : widget.appBar_Color!.withAlpha(30)),
                    backGroundColor_ChildDetails: widget.xDettItem_BackGroundColor ?? (widget.appBar_Color == null ? widget.xDettItem_BackGroundColor ?? Colors.grey[900] : widget.appBar_Color!.withAlpha(30)),
                    onDoubleTapItem: widget.onDoubleTapItem,
                    widgets_RightArea: xLayout_WidgetsRightArea_Item(item, setState),
                    widgets_LeftArea: xLayout_WidgetsLeftArea_Item(item, setState),
                    showTrailingArrow: true,
                    xLayout_Item_RowWidgets: (xCol, item) => xLayout_Item_RowWidgets(xCol, item),
                    // onTapItem: () async {
                    //   await xOnTapItem(item);
                    //   widget.onTapItem != null ? () => widget.onTapItem!(item) : null;
                    // },
                    onLongTapItem: () => xOnLongTapItem(item),
                    edited: widget.edited!,
                    childDetails: Container(
                        width: MediaQuery.of(context).size.width,
                        child: widget.showHead_DettsRowInItem && widget.xDett_xColname != null
                            ? XScheda(item, widget.viewDetts!, showHead: widget.showHead_DettsRowInItem, modePage_Active: false)
                            : Container(
                                child: Column(
                                crossAxisAlignment: CrossAxisAlignment.start,
                                children: liDettsUI
                                    .map((element) => Container(
                                        child: Column(
                                            crossAxisAlignment: CrossAxisAlignment.start,
                                            children: widget.viewDetts!.cols.groupListsBy((element) => element.originY).entries.map((e) {
                                              return Wrap(
                                                  spacing: 3,
                                                  runSpacing: 5,
                                                  children: e.value.map((e) {
                                                    return xLayout_Item_RowWidgets(e, element);
                                                  }).toList());
                                            }).toList())))
                                    .toList(),
                              ))))
            : xLayout_DettItemWidget(item) ??
                XElencoItem(item, widget.view!,
                    funct: widget.functInItem != null ? () => widget.functInItem!(item) : null,
                    showingDetails: item.isShowDetails,
                    margin: EdgeInsets.symmetric(vertical: 2),
                    backGroundColor_ChildMain: (item.isShowDetails && widget.elDettsMode_SchItem == true ? Colors.grey[900] : widget.itemSelected_BackGroundColor ?? (widget.appBar_Color == null ? widget.itemSelected_BackGroundColor ?? Colors.grey[900] : widget.appBar_Color!.withAlpha(30))),
                    backGroundColor_ChildDetails: (item.isShowDetails ? Colors.grey[900] : widget.itemSelected_BackGroundColor ?? (widget.appBar_Color == null ? widget.itemSelected_BackGroundColor ?? Colors.grey[900] : widget.appBar_Color!.withAlpha(30))),
                    onDoubleTapItem: widget.onDoubleTapItem,
                    edited: widget.edited!,
                    showTrailingArrow: false,
                    widgets_RightArea: xLayout_WidgetsRightArea_Item(item, setState),
                    widgets_LeftArea: xLayout_WidgetsLeftArea_Item(item, setState),
                    onLongTapItem: () => xOnLongTapItem(item),
                    onTapItem: () async {
                      await xOnTapItem(item);
                      if (widget.onTapItem != null) {
                        widget.onTapItem!(item);
                      }
                      (widget.schNameToOpen != null && widget.schedaMode == false
                          ? Navigator.pushNamed(context, widget.schNameToOpen!, arguments: item).then((value) {
                              setState(() {
                                isBusy = false;
                                widget.xOnReturnBack != null ? widget.xOnReturnBack!(setState) : null;
                                widget.edited!.value;
                              });

                              rebuildAllChildren(context);
                            }) //
                          : setState(() => item.isShowDetails = item.isShowDetails.not()));
                    },
                    xLayout_Item_RowWidgets: (xCol, item) => xLayout_Item_RowWidgets(xCol, item),

                    //Widget che raffigura la riga che si espande
                    // childMain: Container(
                    //     decoration: item.isShowDetails ? BoxDecoration(border: Border(bottom: BorderSide(width: 1, color: Colors.white))) : null,
                    //     padding: EdgeInsets.symmetric(horizontal: 2, vertical: 8),
                    //     child: Row(children: [
                    //       Expanded(
                    //           child: Column(
                    //               crossAxisAlignment: CrossAxisAlignment.start,
                    //               children: widget.view!.cols.groupListsBy((element) => element.originY).entries.map((e) {
                    //                 return Wrap(
                    //                     spacing: 3,
                    //                     runSpacing: 5,
                    //                     children: e.value.map((e) {
                    //                       return xLayout_Item_RowWidgets(e, item);
                    //                     }).toList());
                    //               }).toList())),
                    //       li.isNotEmpty ? Text((widget.viewDetts!.title ?? "") + ": " + (li.isNotEmpty ? (li.length.toString()) : "0"), style: XStyles.xStyTextForDescr(Colors.white), textAlign: TextAlign.end, overflow: TextOverflow.ellipsis) : Container(),
                    //       xLayout_BTN_Function(item),
                    //       (t != null && t.isNotEmpty) ? xLayout_BTN_ExpandedItem(item) : Container()
                    //     ])),
                    //Widget che raffigura i dettagli che sono dentro la riga espansa
                    childDetails: Column(mainAxisSize: MainAxisSize.min, children: [(widget.liDettsSubArea_Widgets != null ? widget.liDettsSubArea_Widgets!(item) ?? Container() : Container())]));
  }

  Widget xLayout_Item_RowWidgets(XCol xCol, XFDataItem item, {bool noTextWhenCellValueIsNull = true, String? formatDate}) {
    Widget _xContainerOfWidgets;
    Color xColColor = xCol.xmodelXprop.col_Color == Colors.black ? XColors.foregroundLight : xCol.xmodelXprop.col_Color;
    if (xCol.dataType == String && xCol.colKey.startsWith("li").not()) {
      _xContainerOfWidgets = Text(item[xCol.colKey] != null ? item[xCol.colKey] : (noTextWhenCellValueIsNull ? "<No Text>" : ""), maxLines: xCol.multilines ? 3 : 1, style: XStyles.xStyTextForDescr(xColColor), overflow: TextOverflow.fade);
    }
    //WIDGET NEL CASO FOSSE UN DATETIME
    else if (xCol.dataType == DateTime) {
      _xContainerOfWidgets = Text(XUtils.dateToString(item[xCol.colKey] ?? DateTime(1900, 01, 01), format: formatDate ?? xFormat_Date), maxLines: 1, style: XStyles.xStyTextForDescr(xColColor), overflow: TextOverflow.fade);
    }
    //WIDGET NEL CASO FOSSE UN DOUBLE
    else if (xCol.dataType == double) {
      if (xCol.format == "C") {
        _xContainerOfWidgets = Text(XUtils.xFormatToCurrency(context, item[xCol.colKey] ?? 0.0), style: XStyles.xStyTextForDescr(xColColor), textAlign: TextAlign.end, overflow: TextOverflow.fade);
        // Se è un un semplice double
      } else {
        _xContainerOfWidgets = Text(item[xCol.colKey] != null ? item[xCol.colKey].toString() : "0.0", style: XStyles.xStyTextForDescr(xColColor), overflow: TextOverflow.fade);
      }
    }
    //WIDGET NEL CASO FOSSE UN INTERO
    else if (xCol.dataType == int) {
      _xContainerOfWidgets = Text(item[xCol.colKey] != null ? item[xCol.colKey].toString() : "0", style: XStyles.xStyTextForDescr(xColColor), overflow: TextOverflow.fade);

      //Se fosse una lista e voglio prendere la quantità di oggetti dentro
    } else if (xCol.dataType == bool) {
      _xContainerOfWidgets = Container(
        child: XCheckBoxWidget(
            verticalCheckBoxWidget: true,
            label: xCol.colCaption,
            label_Color: xCol.xmodelXprop.col_Color,
            activeColor: xCol.xmodelXprop.col_Color,
            checkColor: XColors.foregroundDark,
            value: (item[xCol.colKey] ?? false),
            onChanged: (value) async {
              setState(() {
                widget.functInItem != null ? widget.functInItem!(item as K) : null;
                widget.edited!.value = true;
                item[xCol.colKey] = value;
              });
            }),
      );
    } else if (xCol.dataType == String && (xCol.colKey.startsWith("li"))) {
      _xContainerOfWidgets = Container();
    } else {
      _xContainerOfWidgets = Text(xCol.headerToolTip + (item[xCol.colKey] != null ? item[xCol.colKey] : (noTextWhenCellValueIsNull ? "<No Text>" : "")), style: XStyles.xStyTextForDescr(Colors.white), overflow: TextOverflow.fade);
    }

    //Se la colonna è Width FLEX
    // if (xCol.resizeStyle == 0) {
    //   return Flexible(flex: (xCol.spanX == 0) ? 1 : xCol.spanX, child: Container(margin: EdgeInsets.symmetric(horizontal: 2), child: _xContainerOfWidgets));
    // }
    // //Se la colonna è Width PROPORTIONAL
    // else if (xCol.resizeStyle == 1) {
    //   return Container(constraints: BoxConstraints(minWidth: xCol.minWidth, maxWidth: xCol.maxWidth), margin: EdgeInsets.symmetric(horizontal: 2), child: _xContainerOfWidgets);
    // }
    // //Se la colonna è Width FIX
    // else {

    return Container(padding: EdgeInsets.only(left: 2), width: xCol.width * XUtils.kforScale, child: _xContainerOfWidgets);
    // }
  }

  Widget xLayout_Widget_IfEmptyList() {
    // var x = widget.BTNEmptyList_BL == null ? Container() : (el_OBJ, parentState) => widget.BTNEmptyList_BL!(el_OBJ, parentState);
    return Container();
  }

  Widget xLayout_AreaElenco() {
    return Container(
        margin: EdgeInsets.symmetric(horizontal: widget.margin_Horizontal ?? 0),
        child: Column(children: [
          widget.searchBar_Active && list.length > 5
              ? Container(
                  decoration: BoxDecoration(
                      border: Border(
                    left: BorderSide(color: XSchedaState.color_AppBar_Background, width: 3),
                    right: BorderSide(color: XSchedaState.color_AppBar_Background, width: 3),
                  )),
                  padding: EdgeInsets.only(bottom: 4),
                  child: Row(children: [
                    Expanded(
                        child: XSearchBar(
                            marginOfSearchBox: EdgeInsets.symmetric(vertical: 2),
                            paddingOfContent: EdgeInsets.only(left: 5),
                            hintStyle: XStyles.xStyTextForSubLabel(widget.searchBar_ColorHint ?? XColors.foregroundLight),
                            textStyle: XStyles.xStyTextForSubLabel(widget.searchBar_ColorText ?? XColors.foregroundLight),
                            colorIconForClear: widget.searchBar_ColorIconClear ?? XColors.foregroundLight,
                            colorIconForSearch: widget.searchBar_ColorIconSearch ?? XColors.foregroundLight,
                            autoFocus: false,
                            onTextChanged: (value) {
                              setState(() {
                                if (value == "") {
                                  searchController.text = "";
                                  filterCurrent = filterAll;
                                } else {
                                  filterCurrent = value;
                                }
                              });
                            },
                            onPressedClear: () {
                              setState(() {
                                filterCurrent = filterAll;
                                searchController.text = "";
                              });
                            },
                            border: UnderlineInputBorder(borderSide: BorderSide(color: widget.searchBar_ColorBorder ?? widget.searchBar_ColorHint ?? widget.searchBar_ColorText ?? XColors.foregroundLight)),
                            disabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: widget.searchBar_ColorBorder ?? widget.searchBar_ColorHint ?? widget.searchBar_ColorText ?? XColors.foregroundLight)),
                            enabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: widget.searchBar_ColorBorder ?? widget.searchBar_ColorHint ?? widget.searchBar_ColorText ?? XColors.foregroundLight)),
                            controller: searchController,
                            colorOfSearchBox: widget.searchBar_Color,
                            hintText: widget.searchBar_hintText ?? "cerca..",
                            iconForSearch: null))
                  ]))
              : Container(),

          //RENDERIZZA L'HEADER DEL L ELENCO
          (widget.headers_Visible ?? true)
              ? Container(
                  padding: EdgeInsets.only(top: 4),
                  decoration: BoxDecoration(
                      border: Border(
                    bottom: BorderSide(color: XSchedaState.color_AppBar_Background, width: 3),
                    left: BorderSide(color: XSchedaState.color_AppBar_Background, width: 3),
                    right: BorderSide(color: XSchedaState.color_AppBar_Background, width: 3),
                  )),
                  child: Row(children: [Expanded(child: SingleChildScrollView(child: Column(children: xLayout_Render_HeadView(widget.view!, border_Visible: widget.borderAree_Header ?? false))))]))
              : Container(),
          //RENDERIZZA L'HEADER DEL L ELENCO

          widget.title_OnTop_Visible == true
              ? Row(
                  children: [
                    Expanded(
                        child: XContainerWithLabel(
                      widget.title_Text,
                      height: widget.heightContainerElTitle,
                      color: widget.colorBackgroundContainerElTitle ?? widget.searchBar_Color ?? XColors.backGroundTitleContainerForElenco,
                      textStyle: widget.title_Style ?? XStyles.xStyTextForTextBase(XColors.foregroundDark),
                    )),
                    widget.BTNtitle_Visible == true
                        ? Container(
                            margin: widget.BTNtitle_Margin ?? EdgeInsets.only(left: 5),
                            height: widget.BTNtitle_Height ?? 25,
                            width: widget.BTNtitle_Width ?? 70,
                            child: XBtnbase(
                              label: widget.BTNtitle_Label ?? "Add New",
                              onPressed: widget.BTNtitle_OnPressed,
                              decoration: BoxDecoration(color: widget.BTNtitle_Color),
                            ),
                          )
                        : Container(),
                  ],
                )
              : Container(),
          SizedBox(height: 7),
          // SizedBox(height: widget.headers_Visible == true && widget.headers_Visible != null ? 3 : 0),
          // widget.headers_Visible == true && widget.headers_Visible != null ? Row(children: widget.headers!) : Container(),
          // SizedBox(height: widget.headers_Visible == true && widget.headers_Visible != null ? 5 : 0),
          // widget.filters_Visible == true && widget.filters_Visible != null ? Row(children: widget.filters!) : Container(),
          // SizedBox(height: widget.filters_Visible == true && widget.filters_Visible != null ? 5 : 0),
          ///Da overridare per aggiungere un tuo widget nell'elenco solo se la lista è vuota
          SizedBox(height: 7),
          Expanded(
              flex: widget.flexForList ?? 18,
              child: ((widget.schedaMode ?? false) && widget.onRefresh_ScrollDownList != null)
                  ? RefreshIndicator(
                      triggerMode: RefreshIndicatorTriggerMode.anywhere,
                      onRefresh: () => widget.onRefresh_ScrollDownList!(context),
                      child: Scrollbar(
                          thumbVisibility: true,
                          controller: scroll_controller,
                          child: ListView(
                            children: (list.isEmpty && (widget.liDetts != null && widget.liDetts!.isEmpty))
                                ? [xLayout_Widget_IfEmptyList()]
                                : widget.liDetts != null
                                    ? widget.liDetts!.where((element) => _xFilter_FilterItem(element)).map((e) {
                                        return widget.item_Widget != null
                                            ? widget.item_Widget!(e) ?? Container() //
                                            : xLayout_ItemWidget(e) ?? Container();
                                      }).toList()
                                    : list.where((element) {
                                        return _xFilter_FilterItem(element);
                                      }).map((e) {
                                        return widget.item_Widget != null
                                            ? widget.item_Widget!(e) ?? Container() //
                                            : xLayout_ItemWidget(e) ?? Container();
                                      }).toList(),
                            controller: scroll_controller,
                          )))
                  : Scrollbar(
                      thumbVisibility: true,
                      controller: scroll_controller,
                      child: ListView(
                        children: (list.isEmpty && (widget.liDetts != null && widget.liDetts!.isEmpty))
                            ? [xLayout_Widget_IfEmptyList()]
                            : widget.liDetts != null
                                ? widget.liDetts!.where((element) => _xFilter_FilterItem(element)).map((e) {
                                    return widget.item_Widget != null
                                        ? widget.item_Widget!(e) ?? Container() //
                                        : xLayout_ItemWidget(e) ?? Container();
                                  }).toList()
                                : list.where((element) => _xFilter_FilterItem(element)).map((e) {
                                    return widget.item_Widget != null
                                        ? widget.item_Widget!(e) ?? Container() //
                                        : xLayout_ItemWidget(e) ?? Container();
                                  }).toList(),
                        controller: scroll_controller,
                      )))
        ]));
  }

  Widget xLayout_Render_HeadView_Widget_forY(
    MapEntry<int, List<XCol<dynamic>>> e,
    List<Widget> children,
    int lastY,
    bool border_separator, {
    bool border_Visible = true,
    Color? border_color,
  }) {
    return Container(
        // padding: EdgeInsets.only(left: 5, right: 5),
        child: Column(mainAxisSize: MainAxisSize.min, crossAxisAlignment: CrossAxisAlignment.start, children: [
      Container(
          // padding: border_Visible ? EdgeInsets.only(bottom: 6, top: 10) : EdgeInsets.only(top: 0, bottom: 0, left: 0, right: 0),
          alignment: Alignment.topLeft,
          // margin: border_Visible ? EdgeInsets.only(top: 5, left: 5, right: 5) : EdgeInsets.only(top: 0, bottom: 0, left: 0, right: 0),
          child: Wrap(
            direction: Axis.horizontal,
            alignment: WrapAlignment.start,
            runAlignment: WrapAlignment.start,
            crossAxisAlignment: WrapCrossAlignment.start,
            children: children,
          ))
    ]));
  }

  double xLayout_maxRowLen = 0.0;
  List<Widget> xLayout_Render_HeadView(XView xview, {bool border_Visible = true}) {
    xLayout_maxRowLen = 0; //resetto
    var grps = widget.view!.cols
        . //
        groupListsBy((element) => element.originY)
        .entries
        .toList();
    var lastY = grps.last.key;
    double avgColsInY = 0;
    grps.map((e) => avgColsInY += e.value.length).toList();
    avgColsInY = avgColsInY / grps.length;
    var r = grps.map(
      (e) {
        //x ogni Y
        //x orgni sottoROW/grp
        double rowLen = 0;
        var child = xLayout_Render_HeadView_Widget_forY(
            e,
            e.value.map((xCol) {
              var xwidgt = Container(
                  padding: EdgeInsets.symmetric(horizontal: 2, vertical: widget.pageMode_Active ? 2 : 5),
                  decoration: BoxDecoration(
                    color: (xCol.xmodelXprop.col_Color == Color(0xff000000) ? XColors.foregroundLight : xCol.xmodelXprop.col_Color).withAlpha(40),
                    border: Border.all(width: 1, color: xCol.xmodelXprop.col_Color == Color(0xff000000) ? XColors.foregroundLight.withAlpha(150) : xCol.xmodelXprop.col_Color.withAlpha(150)),
                  ),
                  constraints: BoxConstraints(minWidth: xCol.width * XUtils.kforScale),
                  child: Text(
                    xCol.colCaption,
                    style: XStyles.xStyTextForSubLabel(xCol.xmodelXprop.col_Color == Color(0xff000000) ? XColors.foregroundLight : xCol.xmodelXprop.col_Color),
                  ));
              rowLen += 10 + 5 + xwidgt.constraints!.minWidth;
              return xwidgt;
            }).toList(),
            lastY,
            avgColsInY > 3);
        if (rowLen > xLayout_maxRowLen) xLayout_maxRowLen = rowLen;
        return child;
      },
    ).toList();

    return r;
  }

  List<Widget> xLayout_Actions() {
    List<Widget> list = List<Widget>.empty(growable: true);
    list.add(_xFilter_build());
    return list;
  }

  onComeBackFromSchDett(K? item) {
    if (neededRealoadData) xLoadDataOnly();
    // if (item == null) {
    // } else {
    //   setState(() {
    //     list.add(item);
    //     // waiterMessage = "Sto caricando i dati...";
    //     // isBusy = true;
    //     // xLoadData_apiCall;
    //   });
    //   // Timer.periodic(Duration(seconds: 1), (timer) {
    //   //   setState(() {
    //   //     waiterMessage = "";
    //   //     isBusy = false;
    //   //     // list.orderBy([Cliente.nickName_XP.col_Name]);
    //   //   });
    //   //   timer.cancel();
    //   // });
    // }
  }

  @override
  Widget build(BuildContext context) {
    return widget.pageMode_Active
        ? Scaffold(
            appBar: widget.appBar_Visible
                ? AppBar(
                    toolbarHeight: widget.appBar_Height ?? null,
                    // leading: widget.xDrawerMenu != null ? null : XBtnbase(icon: Icons.menu, onPressed: widget.onPressed_MENU, width: 40, icon_Size: 28, height: 40),
                    title: Text(
                      widget.title_Text,
                      style: widget.title_Style ?? XStyles.xStyTextForLabel(XColors.foregroundLight),
                    ),
                    backgroundColor: XSchedaState.color_AppBar_Background,
                    actions: [
                        Container(margin: EdgeInsets.symmetric(vertical: 5, horizontal: 5), child: Row(children: xLayout_Actions())),
                        widget.onRefresh_ScrollDownList == null
                            ? Container()
                            : XBtnbase(
                                icon: Icons.replay_outlined,
                                onPressed: widget.onRefresh_ScrollDownList != null ? () => widget.onRefresh_ScrollDownList!(context) : () {},
                                width: 40,
                                height: 40,
                                margin: EdgeInsets.all(5),
                              ),
                      ])
                : null,
            body: widget.widgetBuild_Override ??
                Stack(children: [
                  isBusy ? Container(color: Colors.black.withAlpha(180)) : xLayout_AreaElenco(),
                  isBusy ? XStatefulWidgetBase.LoaderIndicator(isBusy, label: waiterMessage) : Container(),
                ]),
            floatingActionButton: widget.allowAdd ? _buildAddBTN() : widget.floatingActionButton,
            drawer: widget.xDrawerMenu)
        : widget.widgetBuild_Override ?? xLayout_AreaElenco();
  }

  Widget _buildAddBTN() {
    return XBtnbase(
      margin: EdgeInsets.only(bottom: 20),
      width: 50,
      height: 50,
      radiusBorder: 20,
      toolTip_Message: "Aggiungi ${widget.title_Text}",
      icon: Icons.note_add_sharp,
      icon_Size: 40,
      icon_Color: widget.title_Color ?? widget.searchBar_Color,
      backGroundColor: Colors.grey[800]!.withAlpha(150),
      onPressed: widget.cmd_Add != null
          ? () async {
              var res = await widget.cmd_Add!(setState);
              onComeBackFromSchDett(res);
            }
          : null,
    );
  }

  Widget xActionsItem_ViewDett(XFDataItem item, bool dett_Active, void Function(void Function()) parentSetState, XView xView_Elenco, {String? title}) {
    return Container(
        child: XBtnbase(
      height: 40,
      width: 40,
      // label: "Modifica",
      icon_WidthArea: 30,
      label_Style: XStyles.xStyTextForSubLabel(Colors.yellow),
      icon: Icons.edit,
      icon_Size: 23,
      icon_Color: Colors.yellow,
      toolTip_Message: "Modifica questa riga",
      onPressed: () async {
        // Navigator.pop(context);
        super.setState(() {
          // enteredInEditOnCell = true;
        });
        var res = await xPreview_Dialog(xView_Elenco, item);
        if (res != null) {
          item = res.getCloneFull();
        }

        //  showDialog(
        //     context: context,
        //     builder: (context) {
        //       return XAlertDialog(
        //           colorBackGround: XSchedaState.color_BackGround_EditDialog,
        //           actionsBTNarea_Padding: EdgeInsets.symmetric(horizontal: 5),
        //           title_Text: title != null ? "Scheda ${title}" : "Scheda",
        //           btnNO_label: "Annulla",
        //           btnYES_label: "Salva",
        //           btnNO_OnPressed: () {
        //             Navigator.pop(context);
        //           },
        //           btnYES_OnPressed: () {
        //             Navigator.pop(context, item);
        //           },
        //           child:  XScheda(
        //             item,
        //             xView_Scheda,
        //             borderAree_Header: false,
        //             modePage_Active: false,
        //           ));
        //     });
        super.setState(() {
          // enteredInEditOnCell = false;
        });
      },
    ));
    //         PopupMenuButton(
    // padding: EdgeInsets.all(0),
    // icon: Container(padding: EdgeInsets.all(8), decoration: BoxDecoration(borderRadius: BorderRadius.circular(20), color: Colors.grey[800]), child: Icon(Icons.edit)),
    // itemBuilder: (context) {
    //   return [
    //     // PopupMenuItem(
    //     //     height: 40,
    //     //     child: XBtnbase(
    //     //       decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))),
    //     //       height: 40,
    //     //       width: 180,
    //     //       label: "Vedi Dettagli",
    //     //       icon_WidthArea: 30,
    //     //       label_Style: XStyles.xStyTextForSubLabel(Colors.blue),
    //     //       icon: Icons.visibility,
    //     //       icon_Size: 23,
    //     //       icon_Color: Colors.blue,
    //     //       toolTip_Message: "Vedi i dettagli di questa riga",
    //     //       onPressed: () {
    //     //         parentSetState(() {
    //     //           item.isShowDetails = true;
    //     //           item.isSel = item.isSel.not();
    //     //         });
    //     //       },
    //     //     )),
    //     PopupMenuItem(
    //         height: 40,
    //         child: XBtnbase(
    //           decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))),
    //           height: 40,
    //           width: 180,
    //           label: "Modifica",
    //           icon_WidthArea: 30,
    //           label_Style: XStyles.xStyTextForSubLabel(Colors.yellow),
    //           icon: Icons.edit,
    //           icon_Size: 23,
    //           icon_Color: Colors.yellow,
    //           toolTip_Message: "Modifica questa riga",
    //           onPressed: () async {
    //             // Navigator.pop(context);
    //             super.setState(() {
    //               // enteredInEditOnCell = true;
    //             });
    //             await showDialog(
    //                 context: context,
    //                 builder: (context) {
    //                   return XAlertDialog(
    //                       colorBackGround: XSchedaState.color_BackGround_EditDialog,
    //                       actionsBTNarea_Padding: EdgeInsets.symmetric(horizontal: 5),
    //                       title_Text: title != null ? "Scheda ${title}" : "Scheda",
    //                       btnNO_label: "Annulla",
    //                       btnYES_label: "Salva",
    //                       btnNO_OnPressed: () {
    //                         Navigator.pop(context);
    //                       },
    //                       btnYES_OnPressed: () {
    //                         Navigator.pop(context, item);
    //                       },
    //                       child: XScheda(
    //                         item,
    //                         xView_Scheda,
    //                         borderAree_Header: false,
    //                         modePage_Active: false,
    //                       ));
    //                 });
    //             super.setState(() {
    //               // enteredInEditOnCell = false;
    //             });
    //           },
    // ))
    //   ];
    // },
    // iconSize: 22,
    // ));
  }

  Future<File?> cmd_GetMedia(void Function(void Function()) setState, XFDataItem item) async {
    item.isShowDetails = true;
    FocusScope.of(context).unfocus();
    await showDialog(
        context: context,
        barrierDismissible: false,
        builder: (builder) {
          return StatefulBuilder(builder: (context, setStte) {
            return XAlertDialog(
                colorBackGround: Colors.transparent,
                actionsBTNarea_Padding: EdgeInsets.all(1),
                child: XMediaPlayer<XFDataItem>(
                  widget.key,
                  itemOriginal: item,
                  xApp: widget.xApp!,
                  onTake_Audio: (xMedia, xcl, isBusy, state) => cmd_GetAudio(xcl, xMedia),
                  onTake_Picture: (image, xcl, isBusy, state) => onTakePicture(XFile(image), isBusy, setState, xcl),
                  onTake_Video: (video, xcl, isBusy, state) => onTakeVideo(XFile(video), isBusy, setState, xcl),
                ),
                title_Text: "Fotocamera del Lavoro",
                title_Style: XStyles.xStyTextForLabel(Colors.yellow),
                content_insetPadding: EdgeInsets.all(0),
                actionsBTNarea_Child: Row(children: [
                  Expanded(
                      child: XBtnbase(
                    height: 35,
                    backGroundColor: Colors.transparent,
                    onPressed: () async {
                      Navigator.pop(context);
                      await xOnSaveXMedia_INTERNAL(liMediaRAW);
                    },
                    elevation: 0,
                    label: "CHIUDI",
                    label_Style: XStyles.xStyleText(colorText: Colors.red, fontSize: 24, activeBold: false),
                  ))
                ]));
          });
        });

    return null;
  }

  Future<bool?>? xOnSaveXMedia(List<XMediaItem> liXMedia) async {
    return true;
  }

  Future<bool?>? xOnSaveXMedia_INTERNAL(List<XMediaItem> liXMedia) async {
    return await xOnSaveXMedia(liXMedia);
  }

  Future<bool?>? xOnDelXMedia_INTERNAL(XMediaItem xMedia) async {
    var res = await showDialog<bool?>(
      context: context,
      builder: (context) {
        return XAlertDialog(
          title_Text: "Sicuro di voler cancellare il Media ${xMedia.blobURL}?",
          title_Style: XStyles.xStyTextForSubLabel(XColors.warning),
          btnNO_label: "Annulla",
          btnYES_label: "Si",
          btnNO_OnPressed: () => Navigator.pop(context, false),
          btnYES_OnPressed: () => Navigator.pop(context, true),
        );
      },
    );
    if (res != null && res) {
      late Directory direct;
      if (xMedia.mediaType == XEnums.mediaType.audio.value) {
        direct = Directory("${XLibStorage.filePath}/AUDIO/");
      } else if (xMedia.mediaType == XEnums.mediaType.image.value) {
        direct = Directory("${XLibStorage.filePath}/IMMAGINI/");
      } else if (xMedia.mediaType == XEnums.mediaType.video.value) {
        direct = Directory("${XLibStorage.filePath}/VIDEO/");
      }
      direct.listSync().removeWhere((element) => element.path.contains(xMedia.id));
      setState(() {
        liMediaRAW.remove(xMedia);
      });
      res = await xOnDelXMedia(xMedia);
      return res;
    } else {
      return false;
    }
  }

  Future<bool?>? xOnDelXMedia(XMediaItem xMedia) async {
    return true;
  }

  onTakePicture(XFile file, bool isBusy, void Function(void Function()) setState, XFDataItem xfDataItem) async {
    xMedia_onTake_handling(file, isBusy, setState, xfDataItem, XEnums.mediaType.image.value);
  }

  onTakeVideo(XFile file, bool isBusy, void Function(void Function()) setState, XFDataItem xfDataItem) async {
    xMedia_onTake_handling(file, isBusy, setState, xfDataItem, XEnums.mediaType.video.value);
  }

  cmd_GetAudio(XFDataItem xfDataItem, String fileFullPath) async {
    xMedia_onTake_handling(XFile(fileFullPath), isBusy, setState, xfDataItem, XEnums.mediaType.audio.value);
  }

  xMedia_onTake_handling(XFile file, bool isBusy, void Function(void Function()) setState, XFDataItem xfDataItem, int mediatype) async {
    setState(() {
      isBusy = true;
    });

    var xclMedia = XMediaItem(Uuid().v4(), xDocID: xfDataItem.id, mediaType: mediatype);
    // per ora non lo mettiamo visto che sendDataBack lo prende dal loaclPATH e lo mette lui lì
    // payload: await file.readAsBytes(),
    if (mediatype == XEnums.mediaType.video) xclMedia.miniatura = await generateVideoThumbnail(xclMedia.blobURL!);

    final xFile = File("${XLibStorage.filePath}/XMEDIAs/${xclMedia.id}_.${extForMediaType(mediatype)}"); // _ è il marker per DONE !
    await xFile.create(recursive: true);
    await xFile.writeAsBytes(xclMedia.payload!);
    xclMedia.localURI = xFile.path;
    setState(() => liMediaRAW.add(xclMedia));
    rebuildAllChildren(context);
  }

  static String extForMediaType(int mediatype) => mediatype == XEnums.mediaType.video
      ? "mp4"
      : mediatype == XEnums.mediaType.image
          ? "jpg"
          : "aac";

  onSave_EditedPicture(bool isBusy, void Function(void Function()) setState, XMediaItem xfDataItem) async {
    rebuildAllChildren(context);
  }

  Future<Uint8List?> generateVideoThumbnail(String blobURL) async {
    var x = await thumb.VideoThumbnail.thumbnailData(
      video: blobURL,
      imageFormat: thumb.ImageFormat.PNG,
      maxWidth: 128, // specify the width of the thumbnail, let the height auto-scaled to keep the source aspect ratio
      quality: 25,
    );
    return x;
  }

  Widget xActionsItem_AddMedia(XFDataItem item) {
    return XBtnbase(
      icon: Icons.photo_camera_outlined,
      icon_Size: 23,
      width: 40,
      height: 40,
      icon_Color: Colors.orange,
      onPressed: () => cmd_GetMedia(setState, item),
    );
    // Container(
    //     child: PopupMenuButton(
    //   padding: EdgeInsets.all(0),
    //   icon: Container(padding: EdgeInsets.all(8), decoration: BoxDecoration(borderRadius: BorderRadius.circular(20), color: Colors.grey[800]), child: Icon(Icons.photo_camera_outlined, color: Colors.orange)),
    //   itemBuilder: (context) {
    //     return [
    //       PopupMenuItem(height: 40, child: XBtnbase(decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))), height: 40, label: "Aggiungi Immagine", icon_WidthArea: 30, label_Style: XStyles.xStyTextForSubLabel(Colors.green), icon: Icons.image_outlined, icon_Size: 23, icon_Color: Colors.green, toolTip_Message: "Aggiungi un'immagine a questa riga", onPressed: () => cmd_GetMedia(setState, item))),
    //       PopupMenuItem(height: 40, child: XBtnbase(decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))), height: 40, label: "Aggiungi Video", icon_WidthArea: 30, label_Style: XStyles.xStyTextForSubLabel(Colors.blue), icon: Icons.video_call_outlined, icon_Size: 23, icon_Color: Colors.blue, toolTip_Message: "Aggiungi un video a questa riga", onPressed: () => cmd_GetMedia(setState, item))),
    //       PopupMenuItem(
    //           height: 40,
    //           child: XBtnbase(
    //               decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))),
    //               height: 40,
    //               label: "Aggiungi Audio",
    //               icon_WidthArea: 30,
    //               label_Style: XStyles.xStyTextForSubLabel(Colors.orange),
    //               icon: Icons.audiotrack_outlined,
    //               icon_Size: 23,
    //               icon_Color: Colors.orange,
    //               toolTip_Message: "Aggiungi un audio a questa riga",
    //               onPressed: () async {
    //                 await cmd_GetAudio(setState, item);
    //               })),
    //     ];
    //   },
    //   iconSize: 22,
    // ));
  }

  ///Widget per la costruzione dell'Head all'interno dei Dettagli
  Widget xDett_Item_HeadWidget(dynamic itemDett, void Function(void Function()) parentSetState, {XView? xclViewUI}) {
    ScrollController? _scrollController = ScrollController();
    return Scrollbar(
        thumbVisibility: true,
        controller: _scrollController,
        child: SingleChildScrollView(
            controller: _scrollController,
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              mainAxisSize: MainAxisSize.min,
              children: widget.showHead ? xLayout_Render_HeadView(xclViewUI!, border_Visible: false) : [],
            )));
  }

  ///Widget per la costruzione di ItemComplessi utilizzati nei Dettagli della Scheda
  buildXItem<T extends XFDataItem, K>(
    T item,
    List<dynamic> liChildrens,
    void Function(void Function()) parentSetState, {
    Widget Function(dynamic)? dettItem,
    Function(T)? BTNadd_cmdAdd,
    String? BTNadd_label,
    Widget? mainWidget,
    Color? backGround_Color,
    Widget Function(dynamic)? dettWidget,
    EdgeInsetsGeometry? margin,
    List<XPopUpMenuItem>? liPopUpMenu_Items,
    bool border_Visible = false,
    bool title_InMainWidget_Visible = false,
    XView? xView_Scheda,
    XView? xView_Elenco,
    XView? xViewDett,
    List<Widget>? titleLiWidgets,
    bool viewDett_Data = false,
  }) {
    return StatefulBuilder(
      builder: (context, setState) {
        return XElencoItem(item, xView_Scheda!, xViewDetts: xViewDett, margin: margin ?? EdgeInsets.only(left: 10, right: 10, bottom: 10), changeStatoWithTap: true, onTapItem: () {
          parentSetState(
            () {
              item.isShowDetails = item.isShowDetails.not();
            },
          );
        },
            showTrailingArrow: false,
            decorationBackGroundContainer: border_Visible
                ? BoxDecoration(
                    color: backGround_Color ?? Colors.grey[900],
                    border: Border(
                      left: BorderSide(),
                      right: BorderSide(),
                      top: BorderSide(),
                      bottom: BorderSide(),
                    ))
                : BoxDecoration(color: backGround_Color ?? Colors.grey[900]),
            showingDetails: item.isShowDetails,
            showMainWithDetails: true,
            childMain: Column(
              mainAxisSize: MainAxisSize.min,
              children: [
                Row(mainAxisAlignment: MainAxisAlignment.end, children: [
                  mainWidget != null ? Container() : Icon((item.isShowDetails) ? Icons.keyboard_arrow_up_outlined : Icons.keyboard_arrow_down_outlined, color: XColors.foregroundLight),
                  mainWidget != null
                      ? Container()
                      : xView_Elenco != null && widget.showHead
                          ? Expanded(
                              child: Row(children: [
                                Expanded(
                                    child: Wrap(
                                  children: xLayout_RenderDett_HeadDataView(xView_Elenco, item, border_Visible: false),
                                ))
                              ]),
                            )
                          : Container(),
                  mainWidget != null ? Expanded(flex: 2, child: mainWidget) : Container(),
                  Container(margin: EdgeInsets.only(top: 5, right: 5, bottom: 5), child: xActionsItem_ViewDett(item, viewDett_Data, setState, xView_Elenco!)),
                  media_isActive ? Container(margin: EdgeInsets.only(top: 5, right: 5, bottom: 5), child: xActionsItem_AddMedia(item)) : Container(),
                  BTNadd_cmdAdd != null
                      ? Container(
                          margin: EdgeInsets.only(top: 5, right: 5, bottom: 5),
                          child: XBtnbase(
                              width: 40,
                              height: 40,
                              icon_WidthArea: 25,
                              icon: Icons.add,
                              icon_Size: 22,
                              onPressed: () {
                                FocusScope.of(context).unfocus();
                                BTNadd_cmdAdd(item);
                                setState(() {
                                  item.isShowDetails = true;
                                });
                              },
                              elevation: 0,
                              decoration: BoxDecoration(color: Colors.grey[800], borderRadius: BorderRadius.all(Radius.circular(25))),
                              label_Color: XColors.foregroundLight,
                              icon_Color: XColors.done))
                      : Container(),
                  liPopUpMenu_Items != null
                      ? Container(
                          height: 30,
                          child: PopupMenuButton(
                            padding: EdgeInsets.all(1),
                            icon: Icon(Icons.more_vert_outlined),
                            itemBuilder: (context) {
                              return liPopUpMenu_Items
                                  .map((e) => PopupMenuItem(
                                      height: 40,
                                      child: XBtnbase(
                                        decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))),
                                        height: 40,
                                        width: (e.iconImage != null || e.icon != null) ? 250 : 150,
                                        label: e.title,
                                        icon_WidthArea: 50,
                                        label_Style: XStyles.xStyTextForSubLabel(e.color),
                                        icon_Widget: e.icon != null ? null : Container(width: 50, child: e.iconImage),
                                        icon: e.iconImage != null ? null : e.icon,
                                        icon_Size: 23,
                                        icon_Color: e.iconImage != null ? null : e.color,
                                        toolTip_Message: e.toolTip_Message,
                                        onPressed: () => e.onPressed!(context, item),
                                      )))
                                  .toList();
                            },
                            iconSize: 22,
                          ))
                      : Container(),
                ])
              ],
            ),
            childDetails: Column(
              children: [
                // item.isSel
                //     ? xView_Scheda == null
                //         ? Container()
                //         : xDett_Item_HeadWidget(item, parentSetState, xclViewUI: xView_Scheda)
                //     : Container(),
                dettWidget != null
                    ? dettWidget(item)
                    : dettItem != null
                        ? Wrap(
                            spacing: 5,
                            runSpacing: 5,
                            children: liChildrens.map((xclVoce) {
                              return dettItem(xclVoce);
                            }).toList())
                        : Container(),
                Container(
                    // decoration: BoxDecoration(color: colorItem_Lavoro),
                    child: Column(crossAxisAlignment: CrossAxisAlignment.start, children: [
                  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI
                  media_isActive
                      ? (liMediaRAW.isNotEmpty && liMediaRAW.any((element) => element.xDocID == item.id))
                          ? Container(
                              margin: EdgeInsets.all(8),
                              decoration: BoxDecoration(border: Border.all(color: Colors.grey[700]!)),
                              child: Column(children: [
                                Row(children: [Expanded(child: Container(decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))), child: Text("Media", textAlign: TextAlign.center, style: XStyles.xStyTextForSubLabel(XColors.foregroundLight))))]),
                                Column(
                                  children: liMediaRAW.groupListsBy((element) => element.mediaType).entries.map((e) {
                                    if (e.key == XEnums.mediaType.audio.value) {
                                      return builder_AudioArea(liMediaRAW.where((element) => element.mediaType == XEnums.mediaType.audio.value).toList(), item);
                                    } else if (e.key == XEnums.mediaType.image.value) {
                                      return builder_ImmaginiArea(liMediaRAW.where((element) => element.mediaType == XEnums.mediaType.image.value).toList(), parentID: item.id);
                                    } else {
                                      return builder_VideoArea(liMediaRAW.where((element) => element.mediaType == XEnums.mediaType.video.value).toList(), item);
                                    }
                                  }).toList(),
                                )
                              ]),
                            )
                          : Container()
                      : Container(),
                  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI
                ]))
              ],
            ));
      },
    );
  }

  Future<void> play(Uint8List audioPayload, void Function(void Function()) setState) async {
    // await selectedAudioPlayer.play(BytesSource(audioPayload));
  }

  Future<void> pause() async {
    // await selectedAudioPlayer.pause();
  }

  Widget builder_ImmaginiArea(List<XMediaItem>? liImage, {String? parentID, DateTime? dt}) {
    return Container(
        margin: EdgeInsets.only(bottom: 7),
        child: SingleChildScrollView(
            scrollDirection: Axis.horizontal,
            child: Row(
                children: liImage!
                    .where((element) => element.xDocID == (parentID))
                    .map((element) => GestureDetector(
                          onLongPress: () async => await xOnDelXMedia_INTERNAL(element),
                          onTap: () => cmd_OpenPhoto(element, element.id, dtImage: dt),
                          child: Container(margin: EdgeInsets.symmetric(horizontal: 5), width: 100, child: Image.memory(element.payload!, width: 100, height: 100)),
                        ))
                    .toList())));
  }

  cmd_OpenPhoto(XMediaItem img, String imgID, {DateTime? dtImage}) async {
    var res = await showDialog<String?>(
        context: context,
        builder: (builder) {
          return XAlertDialog(
              child: Container(
                  width: MediaQuery.of(context).size.width - 1,
                  height: MediaQuery.of(context).size.height - 1,
                  child: PhotoViewGallery.builder(
                      scrollPhysics: const BouncingScrollPhysics(),
                      builder: (BuildContext context, int index) {
                        return PhotoViewGalleryPageOptions(
                          basePosition: Alignment.center,
                          imageProvider: MemoryImage(img.payload!),
                          initialScale: PhotoViewComputedScale.contained * 1,
                          heroAttributes: PhotoViewHeroAttributes(tag: imgID),
                        );
                      },
                      itemCount: 1,
                      backgroundDecoration: BoxDecoration(color: Colors.grey[900]))),
              title_Text: dtImage != null ? "Foto del ${XUtils.dateToString(dtImage, format: "dd/MM/yy")}" : "Foto",
              title_Style: XStyles.xStyTextForLabel(Colors.yellow),
              content_insetPadding: EdgeInsets.all(0),
              actionsBTNarea_Child: Row(children: [
                Expanded(
                    child: XBtnbase(
                  height: 35,
                  backGroundColor: Colors.transparent,
                  onPressed: () => Navigator.pop(context),
                  elevation: 0,
                  label: "Chiudi",
                  label_Style: XStyles.xStyTextForLabel(Colors.red),
                )),
                Expanded(
                    child: XBtnbase(
                  height: 35,
                  backGroundColor: Colors.transparent,
                  onPressed: () => Navigator.pop(context, "modifica"),
                  elevation: 0,
                  label: "Modifica",
                  label_Style: XStyles.xStyTextForLabel(Colors.blue),
                ))
              ]));
        });
    if (res != null && res == "modifica") {
      var x = await showDialog<bool?>(
        context: context,
        builder: (context) {
          return XAlertDialog(
            content_insetPadding: EdgeInsets.all(0),
            child: Stack(
              children: [
                Image.memory(
                  img.payload!,
                  height: MediaQuery.of(context).size.height,
                  width: MediaQuery.of(context).size.width,
                  key: _imageKey,
                ),
                ImagePainter.memory(
                  img.overlaySurface ?? (img.overlaySurface = createTransparentImage(img.payload!)),
                  height: MediaQuery.of(context).size.height,
                  width: MediaQuery.of(context).size.width,
                  key: _imageKey,
                  controlsAtTop: true,
                  initialColor: Colors.black,
                  colors: [Colors.black, Colors.red, Colors.white, Colors.purple],
                )
              ],
            ),
            btnYES_OnPressed: () {
              Navigator.pop(context, true);
            },
            btnNO_OnPressed: () {
              Navigator.pop(context, null);
            },
            btnNO_label: "Annulla",
            btnYES_label: "Salva",
          );
        },
      );
      if (x != null && x) {
        onSave_EditedPicture(isBusy, setState, img);
        cmd_OnAfter_EditPhoto();
      }
    }
  }

  Uint8List createTransparentImage(Uint8List payloadOri) {
    final imgOri = img.PngDecoder().decode(payloadOri)!;
    final image = img.Image(width: imgOri.width, height: imgOri.height, backgroundColor: img.ColorFloat32(0x00000000));
    // Imposta tutti i pixel come completamente trasparenti (alpha = 0)
    // Converti l'immagine in Uint8List
    final pngBytes = Uint8List.fromList(img.encodePng(image));
    return pngBytes;
  }

  Future<Uint8List?>? cmd_OnAfter_EditPhoto() async {
    return null;
  }

  Widget builder_VideoArea(List<dynamic>? liVideo, XFDataItem? xclItem) {
    return Container(
        margin: EdgeInsets.only(bottom: 7),
        child: SingleChildScrollView(
            scrollDirection: Axis.horizontal,
            child: Row(
                children: liVideo!.where((element) => element.xDocID == xclItem!.id).map((element) {
              return GestureDetector(
                onLongPress: () async => await xOnDelXMedia_INTERNAL(element),
                onTap: () async {
                  // var res = appServices.get
                  File x = await File.fromUri(Uri.parse(element.blobURL!));
                  VideoPlayerController? videoPlayerController = await VideoPlayerController.file(x);
                  bool _isPlaying = false;
                  Future<void> _playVideo() async {
                    await videoPlayerController.play();
                    setState(() {});
                  }

                  Future<void> _pauseVideo() async {
                    await videoPlayerController.pause();
                    setState(() {});
                  }

                  Future<void> _stopVideo() async {
                    await videoPlayerController.pause();
                    await videoPlayerController.seekTo(Duration.zero);
                    setState(() {});
                  }

                  return showDialog(
                      context: context,
                      builder: (context) {
                        videoPlayerController
                          ..addListener(() {
                            final bool isPlaying = videoPlayerController.value.isPlaying;
                            if (isPlaying != _isPlaying) {
                              setState(() {
                                _isPlaying = isPlaying;
                              });
                            }
                          })
                          ..initialize().then((_) {
                            setState(() {});
                          });
                        var i;

                        i = liVideo.firstWhereOrNull((element) => element.xDocID == element.id) != null;

                        return XAlertDialog(
                          content_insetPadding: EdgeInsets.all(0),
                          title_TextAlign: TextAlign.center,
                          title_Text: i != null ? "Video del Lavoro" : "Video del Dettaglio",
                          actionsBTNarea_Child: Row(
                            children: [
                              Expanded(
                                  child: XBtnbase(
                                label: "Pausa",
                                onPressed: () => _pauseVideo(),
                                label_Style: XStyles.xStyTextForLabel(Colors.yellow),
                              )),
                              Expanded(
                                  child: XBtnbase(
                                label: "Play",
                                onPressed: () => _playVideo(),
                                label_Style: XStyles.xStyTextForLabel(Colors.green),
                              ))
                            ],
                          ),
                          child: Stack(
                            children: [Container(width: MediaQuery.of(context).size.width - 10, child: VideoPlayer(videoPlayerController))],
                          ),
                        );
                      }).then((value) {
                    videoPlayerController.dispose();
                  });
                },
                child: Container(
                    margin: EdgeInsets.symmetric(horizontal: 5),
                    decoration: BoxDecoration(color: Colors.grey[800], image: DecorationImage(image: MemoryImage(element.miniatura!))),
                    width: 100,
                    height: 100,
                    child: Container(
                      child: Icon(Icons.play_arrow, size: 28),
                    )),
              );
            }).toList())));
  }

  Widget builder_AudioArea(List<XMediaItem>? liAudio, XFDataItem xclItem) {
    return Container(
        margin: EdgeInsets.only(bottom: 7),
        child: SingleChildScrollView(
            scrollDirection: Axis.horizontal,
            child: Row(
                children: liAudio!
                    .where((element) => element.xDocID == xclItem.id)
                    .map(
                      (element) => Align(
                        alignment: Alignment.centerLeft,
                        child: Container(
                          padding: EdgeInsets.only(
                            bottom: 6,
                            right: 10,
                            top: 6,
                          ),
                          margin: EdgeInsets.symmetric(vertical: 8, horizontal: 12),
                          decoration: BoxDecoration(
                            borderRadius: BorderRadius.circular(10),
                            color: Color(0xFF343145),
                          ),
                          child: Row(
                            mainAxisSize: MainAxisSize.min,
                            children: [
                              // if (!controller.playerState.isStopped)
                              IconButton(
                                onPressed: () async {
                                  if (controller.playerState.isPlaying.not()) {
                                    _preparePlayer(element);
                                    await controller.startPlayer(
                                      finishMode: FinishMode.loop,
                                    );
                                  } else {
                                    await controller.pausePlayer();
                                  }
                                },
                                icon: Icon(
                                  controller.playerState.isPlaying ? Icons.stop : Icons.play_arrow,
                                ),
                                color: Colors.white,
                                splashColor: Colors.transparent,
                                highlightColor: Colors.transparent,
                              ),
                              AudioFileWaveforms(
                                size: Size(MediaQuery.of(context).size.width / 2, 70),
                                playerController: controller,
                                waveformType: WaveformType.fitWidth,
                                playerWaveStyle: playerWaveStyle,
                              ),
                            ],
                          ),
                        ),
                      ),

                      //  GestureDetector(
                      //     onLongPress: () async => await xOnDelXMedia_INTERNAL(element),
                      //     child: Container(
                      //         margin: EdgeInsets.symmetric(horizontal: 5),
                      //         width: 100,
                      //         color: Colors.grey[800],
                      //         height: 100,
                      //         child: Container(
                      //             child: IconButton(
                      //                 icon: Icon(
                      //                   element.isShowDetails ? Icons.pause : Icons.mic,
                      //                   size: 28,
                      //                 ),
                      //                 onPressed: () async {
                      //                   setState(() {
                      //                     element.isShowDetails = !element.isShowDetails;
                      //                   });
                      //                   if (element.isShowDetails) {
                      //                     await play(element.payload!, setState).whenComplete(() => setState(() {
                      //                           element.isShowDetails = false;
                      //                         }));
                      //                   } else {}
                      //                 }))))
                    )
                    .toList())));
  }

  List<Widget> xLayout_RenderDett_HeadDataView(XView xview, dynamic item, {bool border_Visible = true}) {
    xLayout_maxRowLen = 0; //resetto
    var grps = widget.view!.cols
        . //
        groupListsBy((element) => element.originY)
        .entries
        .toList();
    var lastY = grps.last.key;
    double avgColsInY = 0;
    grps.map((e) => avgColsInY += e.value.length).toList();
    avgColsInY = avgColsInY / grps.length;
    var r = grps.map(
      (e) {
        //x ogni Y
        //x orgni sottoROW/grp
        double rowLen = 0;
        var child = xLayout_Render_HeadView_Widget_forY(
            e,
            e.value.map((xCol) {
              var xwidgt = Container(
                  padding: EdgeInsets.symmetric(horizontal: 2, vertical: widget.pageMode_Active ? 2 : 5),
                  // decoration: BoxDecoration(
                  //   color: (xCol.xmodelXprop.col_Color == Color(0xff000000) ? XColors.foregroundLight : xCol.xmodelXprop.col_Color).withAlpha(40),
                  //   border: Border.all(width: 1, color: xCol.xmodelXprop.col_Color == Color(0xff000000) ? XColors.foregroundLight.withAlpha(150) : xCol.xmodelXprop.col_Color.withAlpha(150)),
                  // ),
                  constraints: BoxConstraints(minWidth: xCol.width * XUtils.kforScale),
                  child: xLayout_Item_RowWidgets(xCol, item));
              rowLen += 10 + 5 + xwidgt.constraints!.minWidth;
              return xwidgt;
            }).toList(),
            lastY,
            avgColsInY > 3);
        if (rowLen > xLayout_maxRowLen) xLayout_maxRowLen = rowLen;
        return child;
      },
    ).toList();

    return r;
  }
}

class XPopUpMenuItem {
  String? title;
  String? toolTip_Message;
  Color? color;
  IconData? icon;
  Image? iconImage;
  Function(BuildContext, dynamic)? onPressed;
  XPopUpMenuItem({
    this.color,
    this.onPressed,
    this.title,
    this.icon,
    this.iconImage,
    this.toolTip_Message,
  });
}

class XFilterEl<T> {
  XFilterEl(this.xPropOfItemToFilter, {this.All}) {
    this.Value = this.All;
  }
  List<T> Items = List<T>.empty(growable: true);
  // late T Current;
  T? All;
  T? Value;
  late XProp xPropOfItemToFilter;
  List<XProp> ColsOfXFdataItemToShow = List<XProp>.empty(growable: true);

  static XFilterEl<XEnumDef> fromXEnumDefs(XProp xPropOfItemToFilter, XEnum xEnum, {String all_label = "TUTTI", int all_value = -1, dynamic initialValue}) {
    var xf = XFilterEl<XEnumDef>(xPropOfItemToFilter, All: (all_value < 0 ? null : XEnumDef(label: all_label, value: all_value, backColor: XColors.backgroundDark, textColor: XColors.foregroundLight)));
    xf.Items = xEnum.definitions.values.toList();
    if (initialValue != null) {
      xf.Value = initialValue;
    }
    return xf;
  }

  static XFilterEl from<T>(XProp xPropOfItemToFilter, List<T> items, {T? All, dynamic initialValue}) {
    var xf = XFilterEl<T>(xPropOfItemToFilter, All: All);
    xf.Items = items;
    if (initialValue != null) {
      xf.Value = initialValue;
    }
    return xf;
  }
}
